/* Sistemas Integrados TECNISA

Nome: 0212_GERTRGO.SQL

Descrio:
   Trigger para gravar o log das alteraes

Criao:
   21/01/2010 - Marcelo Alexsandro
*/


/* Tabela AJUSTEPRFORNFIL: Percentual de Ajuste de Preos dos Fornecedores para as Filiais*/
/* Descrio: A trigger insere registros na tabela LOGOPERA a partir de alteraes na tabela de AJUSTEPRFORNFIL*/
/* Objetivo: Gerar um log que vai registrar as alteraes na tabela "Percentual de Ajuste de Preos dos Fornecedores para as Filiais",
             utilizando a tabela Geral de Logs de Operaes*/
CREATE OR REPLACE TRIGGER LOG_SUP_AJUSTEPRFORNFIL
AFTER DELETE OR INSERT OR UPDATE
ON AJUSTEPRFORNFIL  FOR EACH ROW
DECLARE
  V_DSREMOTEADDR VARCHAR2(15);
  V_DSREMOTEHOST VARCHAR2(15);
  V_DSSERVERRDM  VARCHAR2(20);
  V_DSSERVMETHOD VARCHAR2(30);
  V_DSREMOTEOPER VARCHAR2(12);
  V_DESC         VARCHAR2(500);
  V_CDFILLOGOPER VARCHAR2(4);
  V_ITPESQ       VARCHAR2(40);
  V_NMOPERADOR   VARCHAR2(40);
  V_IDTIPOOPER   VARCHAR2(1);
BEGIN
/* IDTIPOOPER - '1' - Incluso, '2' - Alterao, '3' - Excluso*/
   V_DESC         := '';
   V_ITPESQ       := '';
   V_NMOPERADOR   := '';
   V_IDTIPOOPER   := '';
   V_CDFILLOGOPER := '';
   NMUSUARIO(V_NMOPERADOR);
   WEBTUNNING(V_DSREMOTEADDR,
              V_DSREMOTEHOST,
              V_DSSERVERRDM,
              V_DSSERVMETHOD,
              V_DSREMOTEOPER);
   IF UPDATING THEN
      V_DESC   := 'Fornec. '        || '' || :NEW.CDFORNECED              || ' ' ||
                  'Filial '         || '' || :NEW.CDFILIAL                || ' ' ||
                  'Inicial '        || '' || :NEW.DTINIAJPRFORFIL         || ' ' ||
                  'Final '          || '' || NVL(:NEW.DTFINAJPRFORFIL, '')|| ' ' ||
                  '% '              || '' || NVL(:NEW.VRPERAJFORNFIL, '')|| ' ' ||
                  'PI/DSV Fornec. ' || '' || :NEW.IDCONSPERPIAJPR;
      V_ITPESQ       := :NEW.CDFORNECED||:NEW.CDFILIAL||:NEW.DTINIAJPRFORFIL;
      V_CDFILLOGOPER := :NEW.CDFILIAL;
      V_IDTIPOOPER   := '2';
   ELSE
      IF INSERTING THEN
         V_DESC   := 'Fornec. '        || '' || :NEW.CDFORNECED              || ' ' ||
                     'Filial '         || '' || :NEW.CDFILIAL                || ' ' ||
                     'Inicial '        || '' || :NEW.DTINIAJPRFORFIL         || ' ' ||
                     'Final '          || '' || NVL(:NEW.DTFINAJPRFORFIL, '')|| ' ' ||
                     '% '              || '' || NVL(:NEW.VRPERAJFORNFIL, '')|| ' ' ||
                     'PI/DSV Fornec. ' || '' || :NEW.IDCONSPERPIAJPR;
         V_ITPESQ       := :NEW.CDFORNECED||:NEW.CDFILIAL||:NEW.DTINIAJPRFORFIL;
         V_CDFILLOGOPER := :NEW.CDFILIAL;
         V_IDTIPOOPER   := '1';
      ELSE
         IF DELETING THEN
            V_DESC   := 'Fornec. '        || '' || :OLD.CDFORNECED              || ' ' ||
                        'Filial '         || '' || :OLD.CDFILIAL                || ' ' ||
                        'Inicial '        || '' || :OLD.DTINIAJPRFORFIL         || ' ' ||
                        'Final '          || '' || NVL(:OLD.DTFINAJPRFORFIL, '')|| ' ' ||
                        '% '              || '' || NVL(:OLD.VRPERAJFORNFIL, '')|| ' ' ||
                        'PI/DSV Fornec. ' || '' || :OLD.IDCONSPERPIAJPR;
            V_ITPESQ       := :OLD.CDFORNECED||:OLD.CDFILIAL||:OLD.DTINIAJPRFORFIL;
            V_CDFILLOGOPER := :OLD.CDFILIAL;
            V_IDTIPOOPER   := '3';
         END IF;
      END IF;
   END IF;
   V_DESC := SUBSTR(V_DESC, 1, 300);
   INSERT INTO LOGOPERA
      (NMTABELA,
       DTOPERACAO,
       NMRESPOPER,
       IDTIPOOPER,
       DSOPERACAO,
       CDPESQITEM,
       DSRDMUSUOPER,
       DSENDUSUOPER,
       DSNMUSUOPER,
       DSMETUSUOPER,
       CDORESPOPER,
       CDFILLOGOPER)
   VALUES
      ('AJUSTEPRFORNFIL',
       SYSDATE,
       NVL(V_NMOPERADOR,' '),
       V_IDTIPOOPER,
       V_DESC,
       V_ITPESQ,
       V_DSSERVERRDM,
       V_DSREMOTEADDR,
       V_DSREMOTEHOST,
       V_DSSERVMETHOD,
       V_DSREMOTEOPER,
       V_CDFILLOGOPER);
END;
/

-- VERSAO --
BEGIN ATUVEROBJ('LOG_SUP_AJUSTEPRFORNFIL','5.09.000'); END;
/

